; Cross Platform Music Player
; C64 version
; /Mic, 2008


.DEFINE XPMP_ENABLE_CHANNEL_A
.DEFINE XPMP_ENABLE_CHANNEL_B
.DEFINE XPMP_ENABLE_CHANNEL_C

.EQU CMD_NOTE   $00
.EQU CMD_REST	$0C
.EQU CMD_OCTAVE $10
.EQU CMD_DUTY   $20
.EQU CMD_VOL2   $30
.EQU CMD_OCTUP  $40
.EQU CMD_OCTDN  $50
.EQU CMD_PULSE	$70
.EQU CMD_ARPOFF $90
.EQU CMD_FILTER $93
.EQU CMD_HWRM	$94
.EQU CMD_PULMAC	$95
.EQU CMD_CBOFF  $E0
.EQU CMD_CBONCE $E1
.EQU CMD_CBEVNT $E2
.EQU CMD_CBEVVC $E3
.EQU CMD_CBEVVM $E4
.EQU CMD_CBEVOC $E5
.EQU CMD_DETUNE $ED
.EQU CMD_ADSR	$EE
.EQU CMD_VOLSET $F0
.EQU CMD_VOLMAC $F1
.EQU CMD_DUTMAC $F2
.EQU CMD_PORMAC $F3
.EQU CMD_PANMAC $F4
.EQU CMD_VIBMAC $F5
.EQU CMD_SWPMAC $F6
.EQU CMD_VSLMAC $F7
.EQU CMD_ARPMAC $F8
.EQU CMD_JMP    $F9
.EQU CMD_DJNZ   $FA
.EQU CMD_LOPCNT $FB
.EQU CMD_APMAC2 $FC
.EQU CMD_END    $FF

.EQU EFFECT_DISABLED 0

; Zeropage RAM addresses used by the player
.EQU xpmp_songTbl	$03
.EQU xpmp_songTblLo 	$03
.EQU xpmp_songTblHi 	$04
.EQU xpmp_songNum 	$05
.EQU xpmp_dataPtr 	$07
.EQU xpmp_dataPtrLo 	$07
.EQU xpmp_dataPtrHi 	$08
.EQU xpmp_tempZp1	$09
.EQU xpmp_tempZp2	$0A
.EQU xpmp_tempZp3	$0B

.STRUCT xpmp_channel_t
dataPtr		dw
dataPos		dw
delay		dw
delayHi		db	; Note delays are 24 bit unsigned fixed point in 16.8 format
note		db
noteOffs	db
octave		db
duty		db
freq		dw
volume		db
volOffs		db
volOffsLatch	db
freqOffs	dw
freqOffsLatch	dw
detune		dw 
vMac		db
vMacPtr		dw
vMacPos		db
dtMac		db
dtMacPtr	dw
dtMacPos	db
enMac		db
enMacPtr	dw
enMacPos	db
pwMac		db
pwMacPtr	dw
pwMacPos	db
epMac		db
epMacPtr	dw
epMacPos	db
;csMac		db
;csMacPtr	dw
;csMacPos	db
mpMac		db
mpMacPtr	dw
mpMacDelay	db
loop1		db
loop2		db
loopIdx		db
cbEvnote	dw
gate		db
.ENDST


XPMP_VARIABLES:
.DSTRUCT xpmp_channel0,xpmp_channel_t,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.DSTRUCT xpmp_channel1,xpmp_channel_t,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.DSTRUCT xpmp_channel2,xpmp_channel_t,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
xpmp_freqChange:	.db 0
xpmp_volChange: 	.db 0
xpmp_lastNote:		.db 0
xpmp_resfil:		.db 0
xpmp_modevol:		.db 0
xpmp_tempw:		.dw 0
XPMP_VARIABLES_END:


.MACRO ADD_M16_IMM8
	.16bit
	lda	\1
	clc
	adc	#\2
	sta	\1
	lda	\1+1
	adc	#0
	sta	\1+1
	.8bit
.ENDM


; Initialize the music player
; $03..$04 = pointer to song table, $05 = song number
xpmp_init:
	dec	xpmp_songNum
	asl	xpmp_songNum
	clc
	lda	xpmp_songTbl
	adc	xpmp_songNum
	sta	xpmp_songTbl
	lda	xpmp_songTbl+1
	adc	#0
	sta	xpmp_songTbl+1
	
	; Initialize all the player variables to zero
	lda	#0
	ldy	#(XPMP_VARIABLES_END - XPMP_VARIABLES)
	ldx	#0
	xpmp_init_zero:
		sta	XPMP_VARIABLES.w,x
		inx
		dey
		bne	xpmp_init_zero
		
	; Initialize channel data pointers
	.IFDEF XPMP_ENABLE_CHANNEL_A
	ldy	#0
	lda	(xpmp_songTbl),y
	sta	xpmp_channel0.dataPtr.w
	iny
	lda	(xpmp_songTbl),y
	sta	xpmp_channel0.dataPtr.w+1
	.ENDIF	
	.IFDEF XPMP_ENABLE_CHANNEL_B
	ldy	#2
	lda	(xpmp_songTbl),y
	sta	xpmp_channel1.dataPtr.w
	iny
	lda	(xpmp_songTbl),y
	sta	xpmp_channel1.dataPtr.w+1
	.ENDIF	
	.IFDEF XPMP_ENABLE_CHANNEL_C
	ldy	#4
	lda	(xpmp_songTbl),y
	sta	xpmp_channel2.dataPtr.w
	iny
	lda	(xpmp_songTbl),y
	sta	xpmp_channel2.dataPtr.w+1
	.ENDIF	

	; Initialize loop pointers
	lda	#$FF
	.IFDEF XPMP_ENABLE_CHANNEL_A
	sta	xpmp_channel0.loopIdx.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	sta	xpmp_channel1.loopIdx.w
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	sta	xpmp_channel2.loopIdx.w
	.ENDIF

	; Initialize the delays for all channels to 1
	lda 	#1
	.IFDEF XPMP_ENABLE_CHANNEL_A
	sta	xpmp_channel0.delay.w+1
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_B
	sta	xpmp_channel1.delay.w+1
	.ENDIF
	.IFDEF XPMP_ENABLE_CHANNEL_C
	sta	xpmp_channel2.delay.w+1
	.ENDIF
	
	lda	#8
	sta	xpmp_modevol.w
	sta	$D418

	lda	#0
	sta	$D402
	sta	$D409
	sta	$D410
	
	rts


.macro XPMP_COMMANDS

; X contains the command byte
; Y contains zero
xpmp_\1_cmd_00:
;xpmp_\1_cmd_00_2:
	lda	xpmp_channel\1.note.w
	sta	xpmp_lastNote.w
	txa	
	and	#$0F
	sta	xpmp_channel\1.note.w
	ADD_M16_IMM8 xpmp_channel\1.dataPos,2
	iny
	lda	(xpmp_dataPtr),y
	bpl	xpmp_\1_cmd_00_short_note
		tax
		iny
		ADD_M16_IMM8 xpmp_channel\1.dataPos,1
		txa
		and	#$7F
		lsr	a
		tax
		ror	a
		and	#$80
		ora	(xpmp_dataPtr),y
		pha
		iny
		lda	(xpmp_dataPtr),y
		clc
		adc	xpmp_channel\1.delay.w
		sta	xpmp_channel\1.delay.w		; Fractional part
		pla
		adc	#0
		sta	xpmp_channel\1.delay.w+1
		txa
		adc	#0
		sta	xpmp_channel\1.delay.w+2	; Whole part
		jmp	xpmp_\1_cmd_00_got_delay
	xpmp_\1_cmd_00_short_note:	
	tax
	iny
	lda	(xpmp_dataPtr),y
	clc
	adc	xpmp_channel\1.delay.w
	sta	xpmp_channel\1.delay.w		; Fractional part
	txa
	adc	#0
	beq	xpmp_\1_note_ret
	sta	xpmp_channel\1.delay.w+1
	lda	#0
	adc	#0
	sta	xpmp_channel\1.delay.w+2	; Whole part
	xpmp_\1_cmd_00_got_delay:
	lda	#2
	sta	xpmp_freqChange.w
	lda	xpmp_channel\1.note.w
	cmp	#CMD_REST
	beq	xpmp_\1_note_ret
	
	.IFNDEF XPMP_DTMAC_NOT_USED
	lda	xpmp_channel\1.dtMac.w
	beq	+
	jsr	xpmp_\1_reset_dt_mac
	+:
	.ENDIF
	.IFNDEF XPMP_PWMAC_NOT_USED
	lda	xpmp_channel\1.pwMac.w
	beq	+
	jsr	xpmp_\1_reset_pw_mac
	+:
	.ENDIF
	.IFNDEF XPMP_VMAC_NOT_USED
	lda	xpmp_channel\1.vMac.w
	beq	+
	;jsr	xpmp_\1_reset_v_mac
	+:
	.ENDIF
	.IFNDEF XPMP_ENMAC_NOT_USED
	lda	xpmp_channel\1.enMac.w
	beq	+
	jsr	xpmp_\1_reset_en_mac
	+:
	.ENDIF
	.IFNDEF XPMP_MPMAC_NOT_USED
	lda	xpmp_channel\1.mpMac.w
	beq	+
	;jsr	xpmp_\1_reset_mp_mac
	+:
	.ENDIF
	.IFNDEF XPMP_EPMAC_NOT_USED
	lda	xpmp_channel\1.epMac.w
	beq	+
	;jsr	xpmp_\1_reset_ep_mac
	+:
	.ENDIF
	.IFNDEF XPMP_FTMAC_NOT_USED
	;lda	xpmp_channel\1.ftMac.w
	;beq	+
	;jsr	xpmp_\1_reset_ep_mac
	;+:
	.ENDIF
	xpmp_\1_note_ret:
	rts


; Set octave
xpmp_\1_cmd_10:
	txa
	and	#$0F
	asl	a
	asl	a
	sta	xpmp_channel\1.octave.w
	asl	a
	clc
	adc	xpmp_channel\1.octave.w
	sta	xpmp_channel\1.octave.w
	rts	


; Set waveform	
xpmp_\1_cmd_20:
	lda	xpmp_channel\1.duty.w
	and	#4
	sta	xpmp_channel\1.duty.w
	txa
	and	#3
	tax
	lda	#1
	-:
	cpx	#0
	beq	+
	asl	a
	dex
	jmp	-
	+:
	asl	a
	asl	a
	asl	a
	asl	a
	ora	xpmp_channel\1.duty.w
	sta	xpmp_channel\1.duty.w
	lda	#0
	sta	xpmp_channel\1.dtMac.w
	rts


; Set volume (short)
xpmp_\1_cmd_30:
	lda	xpmp_modevol.w
	and	#$F0
	sta	xpmp_modevol.w
	txa
	and	#$0F
	sta	xpmp_channel\1.volume.w
	ora	xpmp_modevol.w
	sta	xpmp_modevol.w
	lda	#1
	sta	xpmp_volChange.w		; Volume has changed
	lda	#EFFECT_DISABLED
	sta	xpmp_channel\1.vMac.w		; Volume set overrides volume macros
	rts

	
; Octave up + note	
xpmp_\1_cmd_40:
	lda	xpmp_channel\1.octave.w
	clc
	adc	#12
	sta	xpmp_channel\1.octave.w
	jmp	xpmp_\1_cmd_00


; Octave down + note
xpmp_\1_cmd_50:
	lda	xpmp_channel\1.octave.w
	clc
	adc	#$F4
	sta	xpmp_channel\1.octave.w
	jmp	xpmp_\1_cmd_00


xpmp_\1_cmd_60:
	rts

; Set pulse width	
xpmp_\1_cmd_70:
	lda	#0
	sta	$D402+\1*7
	sta	xpmp_channel\1.pwMac.w
	txa
	and	#15
	sta	$D403+\1*7
	rts

xpmp_\1_cmd_80:
	rts

	
xpmp_\1_cmd_90:
	txa
	cmp	#CMD_ARPOFF
	bne	+

	; Turn off arpeggio macro
	lda	#EFFECT_DISABLED
	sta	xpmp_channel\1.enMac.w
	sta	xpmp_channel\1.noteOffs.w
	rts

	+:
	cmp	#CMD_FILTER
	bne	+
	
	; Set filter
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	iny
	lda	xpmp_modevol.w
	and	#15
	sta	xpmp_modevol.w
	lda	(xpmp_dataPtr),y
	beq	filter_off_\1
	asl	a
	tax
	dex
	dex
	lda	xpmp_FT_tbl.w,x
	sta	xpmp_tempZp1
	lda	xpmp_FT_tbl.w+1,x
	sta	xpmp_tempZp2
	ldy	#0
	lda	(xpmp_tempZp1),y
	ora	xpmp_modevol.w
	sta	xpmp_modevol.w
	;sta	$D418
	lda	#1
	sta	xpmp_volChange.w
	iny
	lda	(xpmp_tempZp1),y
	sta	$D415
	iny
	lda	(xpmp_tempZp1),y
	sta	$D416
	lda	xpmp_resfil.w
	and	#7
	sta	xpmp_resfil.w
	iny
	lda	(xpmp_tempZp1),y
	ora	xpmp_resfil.w	
	ora	#1<<\1
	sta	xpmp_resfil.w
	sta	$D417
	rts
	filter_off_\1:
	lda	xpmp_resfil.w
	and	#(~(1<<\1))
	sta	xpmp_resfil.w
	sta	$D417
	rts
	
	+:
	cmp	#CMD_HWRM
	bne	+
	
	; Ring modulation enable
	lda	xpmp_channel\1.duty.w
	and	#$F0
	sta	xpmp_channel\1.duty.w
	iny
	lda	(xpmp_dataPtr),y
	beq	xpmp_\1_ringmod_off
	lda	#4
	ora	xpmp_channel\1.duty.w
	sta	xpmp_channel\1.duty.w
	xpmp_\1_ringmod_off:
	rts
	
	+:
	cmp	#CMD_PULMAC
	bne	+
	
	; Pulse width macro
	.IFNDEF XPMP_PWMAC_NOT_USED
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	iny
	lda	(xpmp_dataPtr),y
	sta	xpmp_channel\1.pwMac.w
	beq	xpmp_\1_pulmac_off
	xpmp_\1_reset_pw_mac:
	asl	a
	tax
	dex
	dex
	lda	xpmp_PW_mac_tbl.w,x
	sta	xpmp_channel\1.pwMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_PW_mac_tbl.w+1,x
	sta	xpmp_channel\1.pwMacPtr.w+1
	sta	xpmp_tempZp2
	ldx	#0
	lda	(xpmp_tempZp1,x)
	sta	$D403+\1*7
	lda	#1
	sta	xpmp_channel\1.pwMacPos.w
	xpmp_\1_pulmac_off:
	.ENDIF
	rts
	
	+:
	rts
	
	
xpmp_\1_cmd_A0:
xpmp_\1_cmd_B0:
xpmp_\1_cmd_C0:
xpmp_\1_cmd_D0:
	rts


xpmp_\1_cmd_E0:
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	txa

	cmp	#CMD_CBOFF
	beq	xpmp_\1_cmd_Ex_cboff
	cmp	#CMD_CBONCE
	beq	xpmp_\1_cmd_Ex_cbonce
	cmp	#CMD_CBEVNT
	beq	xpmp_\1_cmd_Ex_cbevnt
	cmp	#CMD_DETUNE
	beq	xpmp_\1_cmd_Ex_detune
	cmp	#CMD_ADSR
	beq	xpmp_\1_cmd_Ex_adsr
	rts

	xpmp_\1_cmd_Ex_cboff:
	xpmp_\1_cmd_Ex_cbonce:
	xpmp_\1_cmd_Ex_cbevnt:
	rts
	
	xpmp_\1_cmd_Ex_detune:
	rts
	
	xpmp_\1_cmd_Ex_adsr:
	iny
	lda	(xpmp_dataPtr),y
	asl	a
	tax
	dex
	dex
	lda	xpmp_ADSR_tbl.w,x
	sta	$D405+\1*7
	lda	xpmp_ADSR_tbl.w+1,x
	sta	$D406+\1*7
	rts

xpmp_\1_cmd_F0:
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	txa
	
	;cmp	#CMD_VOLSET
	;beq	xpmp_\1_cmd_Fx_volset
	cmp	#CMD_JMP
	beq	xpmp_\1_cmd_Fx_jmp
	cmp	#CMD_DJNZ
	beq	xpmp_\1_cmd_Fx_djnz
	cmp	#CMD_LOPCNT
	beq	xpmp_\1_cmd_Fx_lopcnt
	cmp	#CMD_END
	beq	xpmp_\1_cmd_Fx_end
	cmp	#CMD_VOLMAC
	beq	xpmp_\1_cmd_Fx_volmac
	jmp	Fx_\1_part2

	xpmp_\1_cmd_Fx_volmac:
	rts

	xpmp_\1_cmd_Fx_djnz:
	ldx	xpmp_channel\1.loopIdx.w
	dec	xpmp_channel\1.loop1.w,x
	bne	xpmp_\1_cmd_Fx_jmp
	dec	xpmp_channel\1.loopIdx.w
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1
	rts
	
	xpmp_\1_cmd_Fx_lopcnt:
	iny
	lda	(xpmp_dataPtr),y
	inc	xpmp_channel\1.loopIdx.w
	ldx	xpmp_channel\1.loopIdx.w
	sta	xpmp_channel\1.loop1.w,x
	rts

	xpmp_\1_cmd_Fx_jmp:
	iny
	lda	(xpmp_dataPtr),y
	sta	xpmp_channel\1.dataPos.w
	iny	
	lda	(xpmp_dataPtr),y
	sta	xpmp_channel\1.dataPos.w+1
	dec	xpmp_channel\1.dataPos.w	; dataPos will be increased after the return, so we decrease it here
	lda	#$FF
	cmp	xpmp_channel\1.dataPos.w
	bne	+
	dec	xpmp_channel\1.dataPos.w+1
	+:
	rts
	
	xpmp_\1_cmd_Fx_end:
	sta	xpmp_channel\1.note.w
	lda	#2
	sta	xpmp_freqChange.w
	rts
	
	xpmp_\1_cmd_Fx_dutmac:
	.IFNDEF XPMP_DTMAC_NOT_USED
	iny
	lda	(xpmp_dataPtr),y
	sta	xpmp_channel\1.dtMac.w
	beq	xpmp_\1_dutmac_off
	xpmp_\1_reset_dt_mac:
	asl	a
	tax
	dex
	dex
	lda	xpmp_channel\1.duty.w
	and	#4
	sta	xpmp_channel\1.duty.w
	lda	xpmp_dt_mac_tbl.w,x
	sta	xpmp_channel\1.dtMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_dt_mac_tbl.w+1,x
	sta	xpmp_channel\1.dtMacPtr.w+1
	sta	xpmp_tempZp2
	ldx	#0
	lda	(xpmp_tempZp1,x)
	ora	xpmp_channel\1.duty.w
	sta	xpmp_channel\1.duty.w
	lda	#1
	sta	xpmp_channel\1.dtMacPos.w
	xpmp_\1_dutmac_off:
	.ENDIF
	rts

	Fx_\1_part2:
	cmp	#CMD_DUTMAC
	beq	xpmp_\1_cmd_Fx_dutmac
	cmp	#CMD_ARPMAC
	beq	xpmp_\1_cmd_Fx_arpmac
	cmp	#CMD_SWPMAC
	beq	xpmp_\1_cmd_Fx_swpmac
	cmp	#CMD_VIBMAC
	beq	xpmp_\1_cmd_Fx_vibmac
	rts
	
	xpmp_\1_cmd_Fx_vibmac:
	xpmp_\1_cmd_Fx_swpmac:
	rts
	
	xpmp_\1_cmd_Fx_arpmac:
	.IFNDEF XPMP_ENMAC_NOT_USED
	iny
	lda	(xpmp_dataPtr),y
	sta	xpmp_channel\1.enMac.w
	beq	xpmp_\1_arpmac_off
	xpmp_\1_reset_en_mac:
	asl	a
	tax
	dex
	dex
	lda	xpmp_EN_mac_tbl.w,x
	sta	xpmp_channel\1.enMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_EN_mac_tbl.w+1,x
	sta	xpmp_channel\1.enMacPtr.w+1
	sta	xpmp_tempZp2
	ldy	#0
	lda	(xpmp_tempZp1),y
	sta	xpmp_channel\1.noteOffs.w
	lda	#1
	sta	xpmp_channel\1.enMacPos.w
	rts
	xpmp_\1_arpmac_off:
	sta	xpmp_channel\1.noteOffs.w
	.ENDIF
	rts
	
.ENDM


.MACRO XPMP_UPDATE_FUNC 

xpmp_\1_update:
	lda	#0
	sta	xpmp_freqChange.w
	sta	xpmp_volChange.w

	lda	xpmp_channel\1.note.w
	cmp	#CMD_END
	bne	+
	rts					; Playback has ended for this channel - all processing should be skipped
	+:
	
	dec	xpmp_channel\1.delay.w+1
	lda	#$FF
	cmp	xpmp_channel\1.delay.w+1
	bne	+
	dec	xpmp_channel\1.delay.w+2
	+:
	lda	xpmp_channel\1.delay.w+1
	ora	xpmp_channel\1.delay.w+2
	bne	xpmp_\1_update_effects
	
	jsr	xpmp_\1_read_commands
	rts
	
	xpmp_\1_update_effects:
	.IFNDEF XPMP_ENMAC_NOT_USED
	lda	xpmp_channel\1.enMac.w
	beq	xpmp_update_\1_EN_done
	xpmp_update_\1_EN:
	lda	#1
	sta	xpmp_freqChange.w
	lda	xpmp_channel\1.enMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_channel\1.enMacPtr.w+1
	sta	xpmp_tempZp2
	ldy	xpmp_channel\1.enMacPos.w
	lda	(xpmp_tempZp1),y
	cmp	#$80
	beq	xpmp_update_\1_EN_loop
	clc
	adc	xpmp_channel\1.noteOffs.w
	sta	xpmp_channel\1.noteOffs.w
	inc	xpmp_channel\1.enMacPos.w
	jmp	xpmp_update_\1_EN_done
	xpmp_update_\1_EN_loop:
	lda	xpmp_channel\1.enMac.w
	asl	a
	tax
	dex
	dex
	lda	xpmp_EN_mac_loop_tbl.w,x
	sta	xpmp_channel\1.enMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_EN_mac_loop_tbl.w+1,x
	sta	xpmp_channel\1.enMacPtr.w+1
	sta	xpmp_tempZp2
	lda	#1
	sta	xpmp_channel\1.enMacPos.w
	ldx	#0
	lda	(xpmp_tempZp1,x)
	clc
	adc	xpmp_channel\1.noteOffs.w
	sta	xpmp_channel\1.noteOffs.w
	xpmp_update_\1_EN_done:
	.ENDIF

	.IFNDEF XPMP_DTMAC_NOT_USED
	lda	xpmp_channel\1.dtMac.w
	beq	xpmp_update_\1_DT_done
	xpmp_update_\1_DT:
	lda	xpmp_channel\1.duty.w
	and	#4
	sta	xpmp_channel\1.duty.w
	lda	#1
	sta	xpmp_volChange.w
	lda	xpmp_channel\1.dtMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_channel\1.dtMacPtr.w+1
	sta	xpmp_tempZp2
	ldy	xpmp_channel\1.dtMacPos.w
	lda	(xpmp_tempZp1),y
	;cmp	#$00
	beq	xpmp_update_\1_DT_loop
	ora	xpmp_channel\1.duty.w
	sta	xpmp_channel\1.duty.w
	inc	xpmp_channel\1.dtMacPos.w
	jmp	xpmp_update_\1_DT_done
	xpmp_update_\1_DT_loop:
	lda	xpmp_channel\1.dtMac.w
	asl	a
	tax
	dex
	dex
	lda	xpmp_dt_mac_loop_tbl.w,x
	sta	xpmp_channel\1.dtMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_dt_mac_loop_tbl.w+1,x
	sta	xpmp_channel\1.dtMacPtr.w+1
	sta	xpmp_tempZp2
	lda	#1
	sta	xpmp_channel\1.dtMacPos.w
	ldx	#0
	lda	(xpmp_tempZp1,x)
	ora	xpmp_channel\1.duty.w
	sta	xpmp_channel\1.duty.w
	xpmp_update_\1_DT_done:
	.ENDIF

	.IFNDEF XPMP_PWMAC_NOT_USED
	lda	xpmp_channel\1.pwMac.w
	beq	xpmp_update_\1_PW_done
	xpmp_update_\1_PW:
	lda	xpmp_channel\1.pwMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_channel\1.pwMacPtr.w+1
	sta	xpmp_tempZp2
	ldy	xpmp_channel\1.pwMacPos.w
	lda	(xpmp_tempZp1),y
	cmp	#$80
	beq	xpmp_update_\1_PW_loop
	sta	$D403+\1*7
	inc	xpmp_channel\1.pwMacPos.w
	jmp	xpmp_update_\1_PW_done
	xpmp_update_\1_PW_loop:
	lda	xpmp_channel\1.pwMac.w
	asl	a
	tax
	dex
	dex
	lda	xpmp_PW_mac_loop_tbl.w,x
	sta	xpmp_channel\1.pwMacPtr.w
	sta	xpmp_tempZp1
	lda	xpmp_PW_mac_loop_tbl.w+1,x
	sta	xpmp_channel\1.pwMacPtr.w+1
	sta	xpmp_tempZp2
	lda	#1
	sta	xpmp_channel\1.pwMacPos.w
	ldx	#0
	lda	(xpmp_tempZp1,x)
	sta	$D403+\1*7
	xpmp_update_\1_PW_done:
	.ENDIF
	
	lda	xpmp_freqChange.w
	bne	xpmp_update_\1_freq_change
	jmp	xpmp_\1_update_set_vol
	
	rts
	

xpmp_\1_read_commands:
	lda	xpmp_channel\1.dataPtr.w
	clc
	adc	xpmp_channel\1.dataPos.w
	sta	xpmp_dataPtrLo
	lda	xpmp_channel\1.dataPtr.w+1
	adc	xpmp_channel\1.dataPos.w+1
	sta	xpmp_dataPtrHi
	ldy	#0
	lda	(xpmp_dataPtr),y		; Read the first byte of the command
	sta	xpmp_tempZp3
	lsr	a
	lsr	a
	lsr 	a
	and	#$FE
	tax
	lda	xpmp_\1_jump_tbl.w,x
	sta	xpmp_tempw.w
	lda	xpmp_\1_jump_tbl.w+1,x
	sta	xpmp_tempw.w+1			; Get the command handler address and store it in xpmp_tempw
	lda	xpmp_tempZp3
	tax
	jsr	xpmp_call_indirect		; Jump to the command handler
	ADD_M16_IMM8 xpmp_channel\1.dataPos,1

	lda	xpmp_freqChange.w
	cmp	#2				; Have we read a note/rest/end command?
	bne	xpmp_\1_read_commands
	
	xpmp_update_\1_freq_change:
	lda	xpmp_channel\1.note.w
	cmp	#CMD_REST
	beq	xpmp_\1_rest
	cmp	#CMD_END
	beq	xpmp_\1_rest
	lda	xpmp_channel\1.duty.w
	sta	$D404+\1*7
	xpmp_update_\1_freq_change_2:
	lda	xpmp_channel\1.note.w
	clc
	adc	xpmp_channel\1.noteOffs.w
	sta	xpmp_tempZp1
	lda	xpmp_channel\1.octave.w
	adc	xpmp_tempZp1
	asl	a
	tax
	lda	xpmp_freq_tbl.w,x
	sta	xpmp_channel\1.freq.w
	lda	xpmp_freq_tbl.w+1,x
	sta	xpmp_channel\1.freq.w+1
	; TODO: Add detune and freqOffs
	; TODO: Clip frequency if out of range
	lda	xpmp_channel\1.freq.w
	sta	$D400+\1*7
	lda	xpmp_channel\1.freq.w+1
	sta	$D401+\1*7
	lda	xpmp_channel\1.duty.w
	ora	#1
	sta	$D404+\1*7
	lda	#1
	sta	xpmp_channel\1.gate.w
	
	lda	xpmp_lastNote.w
	cmp	#CMD_REST
	beq	xpmp_\1_update_set_vol_2
	jmp	xpmp_\1_update_set_vol_3
	
	xpmp_\1_update_set_vol:
	lda	xpmp_channel\1.note.w
	cmp	#CMD_REST
	beq	xpmp_\1_rest
	xpmp_\1_update_set_vol_2:
	; Update the volume if it has changed
	lda	xpmp_volChange.w
	beq	xpmp_update_\1_no_vol_change
	xpmp_\1_update_set_vol_3:
	lda	xpmp_modevol.w
	sta	$D418
	lda	xpmp_channel\1.duty.w
	ora	xpmp_channel\1.gate.w
	sta	$D404+\1*7
	xpmp_update_\1_no_vol_change:
	rts
		
	; Mute the channel (clear the GATE bit)
	xpmp_\1_rest:
	lda	#0
	sta	$D404+\1*7
	lda	#0
	sta	xpmp_channel\1.gate.w
	
	rts
	

.ENDM

xpmp_call_indirect:
	jmp	(xpmp_tempw.w)
	

.IFDEF XPMP_ENABLE_CHANNEL_A
 XPMP_COMMANDS 0
 XPMP_UPDATE_FUNC 0
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
 XPMP_COMMANDS 1
 XPMP_UPDATE_FUNC 1
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
 XPMP_COMMANDS 2
 XPMP_UPDATE_FUNC 2
.ENDIF


xpmp_update:
.IFDEF XPMP_ENABLE_CHANNEL_A
	jsr 	xpmp_0_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
	jsr 	xpmp_1_update
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
	jsr 	xpmp_2_update
.ENDIF
	rts


.MACRO XPMP_JUMP_TABLE
xpmp_\1_jump_tbl:
.dw xpmp_\1_cmd_00
.dw xpmp_\1_cmd_10
.dw xpmp_\1_cmd_20
.dw xpmp_\1_cmd_30
.dw xpmp_\1_cmd_40
.dw xpmp_\1_cmd_50
.dw xpmp_\1_cmd_60
.dw xpmp_\1_cmd_70
.dw xpmp_\1_cmd_80
.dw xpmp_\1_cmd_90
.dw xpmp_\1_cmd_A0
.dw xpmp_\1_cmd_B0
.dw xpmp_\1_cmd_C0
.dw xpmp_\1_cmd_D0
.dw xpmp_\1_cmd_E0
.dw xpmp_\1_cmd_F0
.ENDM


.IFDEF XPMP_ENABLE_CHANNEL_A
 XPMP_JUMP_TABLE 0
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_B
 XPMP_JUMP_TABLE 1
.ENDIF
.IFDEF XPMP_ENABLE_CHANNEL_C
 XPMP_JUMP_TABLE 2
.ENDIF

 
xpmp_freq_tbl:
.dw $010C,$011C,$012D,$013E,$0151,$0165,$017B,$0191,$01A9,$01C3,$01DD,$01FA
.dw $0218,$0238,$025A,$027D,$02A3,$02CB,$02F6,$0323,$0353,$0386,$03BB,$03F4
.dw $0430,$0470,$04B4,$04FB,$0547,$0597,$05ED,$0647,$06A6,$070C,$0777,$07E9
.dw $0861,$08E1,$0968,$09F7,$0A8F,$0B2F,$0BDA,$0C8E,$0D4D,$0E18,$0EEE,$0FD2
.dw $10C3,$11C2,$12D0,$13EE,$151E,$165F,$17B4,$191D,$1A9B,$1C30,$1DDD,$1FA4
.dw $2186,$2384,$25A1,$27DD,$2A3C,$2CBF,$2F68,$323A,$3537,$3861,$3BBB,$3F48
.dw $430C,$4708,$4B42,$4FBB,$5479,$597F,$5ED1,$6475,$6A6E,$70C2,$7777,$7E91
.dw $8618,$8E11,$9684,$9F77,$A8F3,$B2FF,$BDA3,$C8EA,$D4DC,$E185,$EEEE,$FD23
